clc; clear; close all;

% consider the unit disk as the domain, and assume the image is supported
% in the disk of radius 0.9

%----- plot a bunch of geodesics
s = -0.9:0.05:0.9;
nth1 = 1; dth1 = 2*pi/nth1;
thetas1 = dth1/2:dth1:2*pi-dth1/2;

figure(1);
subplot(1,2,1);
plot(exp(i*[0:2*pi/100:2*pi, 0]), 'b'); hold on;
for j = 1:length(s),
    for k = 1:nth1,
        [x,y] = geodesic(s(j),thetas1(k),100);
        plot(x,y,'r'); hold on
    end
end
axis equal; axis([-1 1 -1 1]);
title('Geodesics')

%----- backprojection geometry

x0 = [0.4]; y0 = [0.8];

nth1 = 40; dth1 = 2*pi/nth1;
thetas1 = dth1/2:dth1:2*pi-dth1/2;

subplot(1,2,2);
plot(exp(i*[0:2*pi/100:2*pi, 0]), 'b'); hold on;
for j = 1:length(x0),
    for k = 1:nth1,
        s0 = hyperS(x0(j),y0(j),thetas1(k));
        [x,y] = geodesic(s0,thetas1(k),100);
        plot(x,y,'r'); hold on
    end
end
plot(x0,y0,'ko');
axis equal; axis([-1 1 -1 1]);
title('Backprojection geometry')
